<?php

error_reporting(E_ALL ^ E_NOTICE);

require_once(t3lib_extMgm::extPath('kmcs_fileedit', 'mod1/class.tx_kmcsfileedit_util.php'));

class tx_kmcsfileedit_browser {

  private static $_extConfig = array();

  /**
   * ajaxID Wrapper for getFiles
   */
  public function ajaxGetFiles($params, &$ajaxObj) {
    $params = json_decode(file_get_contents('php://input'), true);
    $result = self::getFiles($params['file']);
    self::printJson(array('result' => $result));
  }

  public static function getFiles($folder = '') {
    $realFilePath = self::getRealFilePath($folder);
    if(is_dir($realFilePath)) {
       $list = array();
       $listFiles = array();
       $files = scandir($realFilePath);
       $folder .= (empty($folder) ? '' : '/');
       $showHidden = self::getExtConf('show_hidden');
       foreach($files as $file) {
         if(empty($showHidden) && $file{0} == '.') {
           continue;
         }
         if(is_dir($realFilePath . '/' . $file) && $file != '.' && $file != '..') {
           $list[] = array('name' => $file, 'url' => $folder . $file, 'isDir' => true);
         } elseif(is_file($realFilePath . '/' . $file)) {

           $listFiles[] = array('name' => $file, 'url' => $folder . $file, 'time' => filemtime($realFilePath . '/' . $file), 'editable' => preg_match('/' . self::getExtConf('editable_ext') . '/', $file) > 0);
         }
       }
       return(array_merge($list, $listFiles));
    }
    return (false);
  }
  
  public function ajaxCreateFile($parms,&$ajaxObj) {
    $params = json_decode(file_get_contents('php://input'), true);
    $result = self::createFile($params['basePath'], $params['name']);
    self::printJson(array('result' => $result));
  }
  
  public static function createFile($basePath, $name) {
    $realFilePath = self::getRealFilePath($basePath);
    if($realFilePath{strlen($realFilePath) - 1} != '/') {
        $realFilePath .= '/';
    }
    touch($realFilePath . $name);
      if($basePath{strlen($basePath)-1} != '/') {
          $basePath .= '/';
      }
    return(array('file' => $basePath . $name));
  }
  
  public function ajaxCreateFolder($parms,&$ajaxObj) {
    $params = json_decode(file_get_contents('php://input'), true);
    $result = self::createFolder($params['basePath'], $params['name']);
    self::printJson(array('result' => $result));
  }
  
  public static function createFolder($basePath, $name) {
    $realFilePath = self::getRealFilePath($basePath);
    if($realFilePath{strlen($realFilePath) - 1} != '/') {
        $realFilePath .= '/';
    }
    mkdir($realFilePath . $name);
    if($basePath{strlen($basePath)-1} != '/') {
          $basePath .= '/';
    }
    return(array('file' => $basePath . $name));
  }
  
  public function ajaxRename($params, &$ajaxObj) {
    $params = json_decode(file_get_contents('php://input'), true);
    $result = self::rename($params['file'], $params['name']);
    self::printJson(array('result' => $result));
  }
  
  public static function rename($file, $name) {
    $realFilePath = self::getRealFilePath($file);
    if($realFilePath{strlen($realFilePath) - 1} == '/') {
        $realFilePath = substr($realFilePath, 0, -1);
    }
    $arrPath = explode('/', $realFilePath);
    array_pop($arrPath);
    
    $basePath = join('/', $arrPath) . '/';
    
    $newFile = $realFilePath;
    
    if(file_exists($realFilePath)) {
      rename($realFilePath, $basePath . $name);
      $newFile = $basePath . $name;
    }
    
    return(array('file' => $newFile));
  }

  /**
   * ajaxID Wrapper for getFileContent
   */
  public function ajaxGetFileContent($params, &$ajaxObj) {
    $params = json_decode(file_get_contents('php://input'), true);
    $result = self::getFileContent($params['file']);
    self::printJson(array('result' => $result));
  }

  public static function getFileContent($file) {
    $realFilePath = self::getRealFilePath($file);
    $content = file_get_contents($realFilePath);
    if(!self::is_utf8($content)) {
       $content = utf8_encode($content);
    }
    return(array('content' => $content, 'writeable' => is_writeable($realFilePath), 'time' => filemtime($realFilePath)));
  }

  /**
   * ajaxID Wrapper for saveFileContent
   */
  public function ajaxSaveFileContent($params, &$ajaxObj) {
    $params = json_decode(file_get_contents('php://input'), true);
      
    $result['settings'] = $GLOBALS['BE_USER']->uc['tools_kmcsfileedit_EditorSettings'];
    if(!isset($result['settings']['enablePHPSyntaxCheck'])) {
       $result['settings']['enablePHPSyntaxCheck'] = true;
    }

    $content = base64_decode($params['content']);
    if(!empty($params['contentType']) && $params['contentType'] == 'php' 
        && $params['force'] === false && $result['settings']['enablePHPSyntaxCheck'] === true) {
        $syntaxInfo = tx_kmcsfileedit_util::php_syntax_check(null, $content, $params['file']);   
        if($syntaxInfo['success'] !== true) {
            $result = array('error' => array('code' => 'syntax_check_failed', 'description' => $syntaxInfo['description']));
        } else {
            $result = self::saveFileContent($params['file'], $content);
        }
    } else {
      $result = self::saveFileContent($params['file'], $content);
    }
    
    self::printJson(array('result' => $result));
  }

  public static function saveFileContent($file, $content) {
    $realFilePath = self::getRealFilePath($file);
    if(is_writeable($realFilePath)) {
      $filemtimeBefore = filemtime($realFilePath);
      file_put_contents($realFilePath, $content);
      if(filemtime($realFilePath) !== $filemtimeBefore) {
        return (true);
      }
    }
    return (false);
  }

  /**
   * ajaxID Wrapper for checkFilesChanged
   */
  public function ajaxCheckFilesChanged($params, &$ajaxObj) {
    /**
     * @TODO: to implement!!
     */
  }

  public static function checkFilesChanged($files) {
    foreach($files as &$file) {
      $realFilePath = self::getRealFilePath($file['file']);
      $currentFileTime = filemtime($realFilePath);
      if($currentFileTime != $file['time']) {
        $file['status'] = 'changed';
        $file['time'] = $currentFileTime;
      }
    }
    return($files);
  }

  public function ajaxSaveEditorSetting($params, &$ajaxObj) {
    $params = json_decode(file_get_contents('php://input'), true);
    self::saveEditorSetting($params['name'], $params['value']);
  }

  public function saveEditorSetting($name, $value) {
    if(!is_array($GLOBALS['BE_USER']->uc['tools_kmcsfileedit_EditorSettings'])) {
      $GLOBALS['BE_USER']->uc['tools_kmcsfileedit_EditorSettings'] = array();
    }
    $GLOBALS['BE_USER']->uc['tools_kmcsfileedit_EditorSettings'][$name] = $value;
    $GLOBALS['BE_USER']->writeUC();
  }

  public function ajaxGetInitialData($params, &$ajaxObj) {
    /**
     * @TODO: read initial opened folders, read inital opened files
     */
    $result = array();
    $rootTree = self::getFiles();
    $result['settings'] = $GLOBALS['BE_USER']->uc['tools_kmcsfileedit_EditorSettings'];
    if(!empty($result['settings']['openedFiles']) && is_array($result['settings']['openedFiles'])) {
      foreach($result['settings']['openedFiles'] as $file) {
        $folders = explode('/', dirname($file));
        $path = '';
        $currentFolders = &$rootTree;
        $openedFolder = array();
        if(!empty($folders) && is_array($folders)) {
          foreach($folders as $folder) {
            if(empty($folder)) {
              break;
            }
            $path .= empty($path) ? $folder : '/' . $folder;

            
            //find folder by name
            $foundFolder = false;
            foreach($currentFolders as &$arrFolder) {
               if($arrFolder['isDir'] && $arrFolder['name'] == $folder) {
                if(!isset($arrFolder['childNodes'])) {
                   $arrFolder['childNodes'] = self::getFiles($path);
                   $currentFolders = &$arrFolder['childNodes'];
                 }
                $foundFolder = true;
                break;
              }
            }
            //not found?
            if($foundFolder == false) {
              break;
            }

          }//eof foreach folders
          
        }
      }
    }
    $result['tree'] = $rootTree;
    self::printJson(array('result' => $result));
  }

  private static function findFolderByName(&$arr, $folderName, $myFolder) {
     foreach($arr as &$folder) {
       if($folder['isDir'] && $folder['name'] == $folderName) {
          $folder['test'] = 'TEEEEEEEEEEEEST';
          $myFolder = &$folder;
          $myFolder['haha'] = 'FUUUUUUUUUUUU';
          return(true);
       }
     }

     return(false);
  }

  private static function getExtConf($name) {
    if(empty(self::$_extConfig)) {
      self::$_extConfig = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['kmcs_fileedit']);
    }
    return(self::$_extConfig[$name]);
  }

  private static function getRealFilePath($file) {
    $homeDir = self::getExtConf('home_dir');
    if(empty($homeDir)) {
      $homeDir = PATH_site;
    }
    if($homeDir{strlen($homeDir)-1} != '/') {
      $homeDir .= '/';
    }
    if(empty($file)) {
      return(substr($homeDir, 0, strlen($homeDir)-1));
    }
    return ($homeDir . $file);
  }

  private static function is_utf8($str){
    $strlen = strlen($str);
    for($i=0; $i<$strlen; $i++){
      $ord = ord($str[$i]);
      if($ord < 0x80) continue; // 0bbbbbbb
      elseif(($ord&0xE0)===0xC0 && $ord>0xC1) $n = 1; // 110bbbbb (exkl C0-C1)
      elseif(($ord&0xF0)===0xE0) $n = 2; // 1110bbbb
      elseif(($ord&0xF8)===0xF0 && $ord<0xF5) $n = 3; // 11110bbb (exkl F5-FF)
      else return false; // ungltiges UTF-8-Zeichen
      for($c=0; $c<$n; $c++) // $n Folgebytes? // 10bbbbbb
        if(++$i===$strlen || (ord($str[$i])&0xC0)!==0x80)
          return false; // ungltiges UTF-8-Zeichen
    }
    return true; // kein ungltiges UTF-8-Zeichen gefunden
  }

  private static function printJson($result) {
    header('Content-Type: application/json');
    echo json_encode($result);
  }

}

?>