<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 Timo Kiefer <timo.kiefer@kmcs.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */


$LANG->includeLLFile('EXT:kmcs_fileedit/mod1/locallang.xml');
//require_once(PATH_t3lib . 'class.t3lib_scbase.php');
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]



/**
 * Module 'File Editor' for the 'kmcs_fileedit' extension.
 *
 * @author	Timo Kiefer <timo.kiefer@kmcs.de>
 * @package	TYPO3
 * @subpackage	tx_kmcsfileedit
 */
class  tx_kmcsfileedit_module1 extends t3lib_SCbase {
				var $pageinfo;

				var $qxsettings = array();

				/**
				 * Initializes the Module
				 * @return	void
				 */
				function init()	{
					global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

					parent::init();

				}


				/**
				 * Main function of the module. Write the content to $this->content
				 * If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
				 *
				 * @return	[type]		...
				 */
				function main()	{
					global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

					$this->qxsettings['kmcs.t3fileedit.T3Connection.Url'] = 'ajax.php';
                                        $this->qxsettings['kmcs.t3fileedit.TextAreaCoding.CodeMirrorResource'] = '../typo3conf/ext/kmcs_fileedit/mod1/qx/';
				}

				/**
				 * Prints out the module HTML
				 *
				 * @return	void
				 */
				function printContent()	{
					$jsonQxSettings = json_encode($this->qxsettings);

					$applicationScript = '../typo3conf/ext/kmcs_fileedit/mod1/qx/script/kmcs.t3fileedit-1.3.0.js';

					if (isset($_SERVER['HTTP_ACCEPT_ENCODING'])) {
					       // Get all available encodings
					       $encodings = explode(',', strtolower(preg_replace("/\s+/", "", $_SERVER['HTTP_ACCEPT_ENCODING'])));
						 // Check for gzip header
					       if (in_array('gzip', $encodings)) {
						  //$applicationScript .= '.gz';
					       }
					}

					echo <<<HTML
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>kmcs.t3fileedit</title>
  <script type="text/javascript">
   window.qx = {
     \$\$environment : {$jsonQxSettings}
   };
  </script>
  <script type="text/javascript" src="../typo3conf/ext/kmcs_fileedit/mod1/qx/resource/CodeMirror/js/codemirror-compressed-4.3.js"></script>
  <script type="text/javascript" src="{$applicationScript}"></script>
  <link rel="stylesheet" href="../typo3conf/ext/kmcs_fileedit/mod1/qx/resource/CodeMirror/css/codemirror-4.3.css" type="text/css" />
</head>
<body></body>
</html>
HTML;
				}

				
		}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/kmcs_fileedit/mod1/index.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/kmcs_fileedit/mod1/index.php']);
}




// Make instance:
$SOBE = t3lib_div::makeInstance('tx_kmcsfileedit_module1');
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>
